'use strict';

app.controller('MetadataCtrl', ['$scope', 'FormService', 'RestService', 'formData', 'metadataLanguages', 'ratings', 'descriptiveMetadataExtractors',
    function ($scope, FormService, RestService, formData, metadataLanguages, ratings, descriptiveMetadataExtractors) {
	
    $scope.formData = buildFormData(formData);
    $scope.descriptiveMetadataExtractors = descriptiveMetadataExtractors;
    $scope.ratings = ratings;
    $scope.metadataLanguages = metadataLanguages;

	$scope.submit = function (form) {
        FormService.submitForm('metadata', presaveFormData($scope.formData), form, $scope);
    };

    $scope.onlineMetadataEnabled = function() {
    	return $scope.formData.descriptiveMetadataExtractor == 'ONLINE_VIDEO_SOURCES';
    }

    $scope.refreshVideoMetadata = function() {
        $scope.videoMetadataRefreshInProgress = true;
        RestService.invokeAction('forceVideoFilesMetadataUpdate', null, true, function(response) {            
            $scope.videoMetadataRefreshInProgress = false;            
        }, function(response) {            
            $scope.videoMetadataRefreshInProgress = false;
        })
    }

	function buildFormData(formData) {		
    	if('filterVideosByRating' in formData) {
    		formData['filterVideosByRatingEnabled'] = true;
    	} else {
    		formData['filterVideosByRatingEnabled'] = false;
    		formData['filterVideosByRating'] = 'NC17';
    	}
    	return formData;
    }

    function presaveFormData(formData) {
    	var formCopy = JSON.parse(JSON.stringify(formData));
    	if(formCopy.filterVideosByRatingEnabled == false) {
    		delete formCopy['filterVideosByRating'];
    	}
    	delete formCopy['filterVideosByRatingEnabled'];
    	return formCopy;
    }

}]);