'use strict';

app.controller('SubtitlesCtrl', ['$scope', 'FormService', 'formData', 
    function ($scope, FormService, formData) {
	
    $scope.formData = formData;
    $scope.hardSubsFontColor = buildFontColor(formData);

    $scope.submit = function (form) {
        FormService.submitForm('delivery', presaveFormData($scope.formData), form, $scope);
    };

    $scope.openSubtitlesPasswordRequired = function() {
    	var username = $scope.formData.subtitles.openSubtitles['userName'];
    	return username != null && username.trim().length > 0;
    };

    function buildFontColor(formData) {      
        if( formData.subtitles['hardSubsFontColor'] != null ) {
            return '#' + formData.subtitles['hardSubsFontColor'];
        } else {
            return '#ffffff';
        }
    }

    function presaveFormData(formData) {
    	var formCopy = JSON.parse(JSON.stringify(formData));
    	var username = formCopy.subtitles.openSubtitles['userName'];
    	var password = formCopy.subtitles.openSubtitles['password'];

    	if(username == null || username.trim() == '') {
    		delete formCopy.subtitles.openSubtitles['userName'];
    	}

    	if(password == null || password.trim() == '') {
    		delete formCopy.subtitles.openSubtitles['password'];
    	}

        if($scope.hardSubsFontColor.toLowerCase() != '#ffffff') {
            // white is default, don't send it, otherwise yes
            formCopy.subtitles['hardSubsFontColor'] = $scope.hardSubsFontColor.replace('#', '');
        }

    	return formCopy;
    }


}]);